Bug 211786 - Yum/rpm periodicly hangs
Yum/rpm periodicly hangs
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: yum (Show other bugs)
5
i386 Linux
medium Severity urgent
: ---
: ---
Assigned To: Jeremy Katz
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-10-22 16:39 EDT by Heiko Adams
Modified: 2014-01-21 17:55 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-04-25 14:30:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Heiko Adams 2006-10-22 16:39:51 EDT
Description of problem:
Since updating to kernel 2.6.18-1.2200.fc5 yum periodicly hangs on startup. With
some luck yum works one time correct until next reboot, without that luck yum
just hangs after starting it without any error message.
When trying to install packets with rpm it could be that rpm damages the rpm
database. When trying to rebuild the database i allways get memory access
violations.

Version-Release number of selected component (if applicable):
yum-2.6.1-0.fc5
kernel 2.6.18-1.2200.fc5
rpm-4.4.2-15.2

How reproducible:
allway

Steps to Reproduce:
1. Boot kernel 2.6.18
2. start "yum update" or install a packet with rpm
  
Actual results:
yum/rpm work correct on first start but on next start it hangs without any error
message

Expected results:
yum/rpm should work correct on every start

Additional info:
This problem only happens on kernel 2.6.18. When using kernel 2.6.17 this
problems aren't present.
Comment 1 Tomasz Ostrowski 2006-10-26 07:02:59 EDT
Today morning I have found my daily yum update hung in running state. I tried to
strace it to find out what is it doing but it didn't do any syscall. I tried to
"kill -SEGV [pid_of_yum]" because I hoped it will write something useful to its
stderr and cron will mail it to me, but it didn't - only "segmentation fault".

It leaved /var/lib/rpm database in locked state so I've made a backup of it,
removed /var/lib/rpm/__db.* and run "rpm --rebuilddb". I cannot reproduce this
hang anymore.

I know that redhat servers died today, but I do not use them - I have my own
list of local mirrors for core, updates and extras. So this should not be a cause.

$ uname -a
Linux pancernik.batory.org.pl 2.6.18-1.2200.fc5 #1 Sat Oct 14 16:59:26 EDT 2006
i686 i686 i386 GNU/Linux
$ rpm -q rpm yum
rpm-4.4.2-15.2
yum-2.6.1-0.fc5
Comment 2 renke 2006-11-07 09:05:12 EST
I have similar problems with x86_64 - only the first run of yum (or yum-based
tools like package-cleanup) works, all other starts ends in the situation Heiko
described or (sometimes) a segfault.
Comment 3 Michel Alexandre Salim 2006-12-01 01:31:30 EST
As a workaround, could yum print out a notice if the RPM database is currently
locked? It is not a faulty behaviour in itself (sometimes I'd start yum while an
RPM transaction is ongoing, for instance) but it would be nice to know the
reason while yum appears to just sit there idling.
Comment 4 Peter Ennis 2007-02-07 21:12:27 EST
Same problem with last update.
Box kept up to date.
Killed yum pid.
Used yum clean all
Try again and it still hangs.
Old or new problem?


[Philip@fc5 ~]$ uname -a
Linux fc5.adaept.com 2.6.18-1.2257.fc5smp #1 SMP Fri Dec 15 16:33:51 EST 2006
i686 i686 i386 GNU/Linux
[Philip@fc5 ~]$


[root@fc5 ~]# yum update
Loading "installonlyn" plugin
Setting up Update Process
Setting up repositories
livna                                                                [1/4]
livna                     100% |=========================|  951 B    00:00
core                                                                 [2/4]
core                      100% |=========================| 1.1 kB    00:00
updates                                                              [3/4]
updates                   100% |=========================| 1.2 kB    00:00
extras                                                               [4/4]
extras                    100% |=========================| 1.1 kB    00:00
Reading repository metadata in from local files
primary.xml.gz            100% |=========================| 134 kB    00:00
livna     : ################################################## 345/345
Added 345 new packages, deleted 0 old in 13.75 seconds
primary.xml.gz            100% |=========================| 767 kB    00:02
core      : ################################################## 2207/2207
Added 2207 new packages, deleted 0 old in 60.28 seconds
primary.xml.gz            100% |=========================| 387 kB    00:01
updates   : ################################################## 1067/1067
Added 1067 new packages, deleted 0 old in 36.39 seconds
primary.xml.gz            100% |=========================| 1.9 MB    00:03
extras    : ################################################## 6315/6315
Added 6315 new packages, deleted 0 old in 166.78 seconds
Comment 5 Seth Vidal 2007-02-07 22:19:13 EST
Not answering your question but:

> Same problem with last update.
> Box kept up to date.
> Killed yum pid.
> Used yum clean all
> Try again and it still hangs.
> Old or new problem?

was this trying for a haiku?


Comment 6 Peter Ennis 2007-02-08 12:26:22 EST
No, but I will take it - domo arigato :)

FWIW The following process fixed it for me:

Ref:
http://www.serpentine.com/blog/2007/01/04/dealing-with-yum-hangs-on-fc6/

[root@fc5 ~]# killall -9 yum
[root@fc5 ~]# cd /var/lib/rpm
[root@fc5 rpm]# ls
Basenames     __db.002  Group       Providename     Requireversion
Conflictname  __db.003  Installtid  Provideversion  Sha1header
__db.000      Dirnames  Name        Pubkeys         Sigmd5
__db.001      Filemd5s  Packages    Requirename     Triggername
[root@fc5 rpm]#
[root@fc5 rpm]# rm -f /var/lib/rpm/__db.*
[root@fc5 rpm]# ls
Basenames     Group       Providename     Requireversion
Conflictname  Installtid  Provideversion  Sha1header
Dirnames      Name        Pubkeys         Sigmd5
Filemd5s      Packages    Requirename     Triggername
[root@fc5 rpm]#
[root@fc5 rpm]# yum clean all
Loading "installonlyn" plugin
Cleaning up Everything
0 headers removed
0 packages removed
12 metadata files removed
0 cache files removed
4 cache files removed
[root@fc5 rpm]#yum update
...
Added 6283 new packages, deleted 0 old in 166.40 seconds
Resolving Dependencies
--> Populating transaction set with selected packages. Please wait.
---> Downloading header for python-imaging to pack into transaction
set.
python-imaging-1.1.6-1.fc 100% |=========================|  34 kB   
00:00
---> Package python-imaging.i386 0:1.1.6-1.fc5 set to be updated
--> Running transaction check

Dependencies Resolved

=============================================================================
 Package                 Arch       Version          Repository      
 Size
=============================================================================
Updating:
 python-imaging          i386       1.1.6-1.fc5      extras          
 458 k

Transaction Summary
=============================================================================
Install      0 Package(s)
Update       1 Package(s)
Remove       0 Package(s)
Total download size: 458 k
Is this ok [y/N]: y
Downloading Packages:
(1/1): python-imaging-1.1 100% |=========================| 458 kB   
00:01
Running Transaction Test
Finished Transaction Test
Transaction Test Succeeded
Running Transaction
  Updating  : python-imaging               #########################
[1/2]
  Cleanup   : python-imaging               #########################
[2/2]

Updated: python-imaging.i386 0:1.1.6-1.fc5
Complete!
[root@fc5 rpm]#
Comment 7 Jeremy Katz 2007-04-25 14:30:39 EDT
There was a kernel futex() bug lingering, but it seems to fixed now

Note You need to log in before you can comment on or make changes to this bug.